package networks;

import javax.swing.*;
import java.util.*;
import javax.swing.text.*;
import java.io.*;
import java.net.*;
import javax.swing.text.html.*;

import searchenginewrappers.*;

/**
 * Insert the type's description here.
 * Creation date: (7/18/2001 7:58:00 PM)
 * @author: Administrator
 */
public class HTMLDocumentParser {
	private HTMLDocument _HTMLDoc;
/**
 * HTMLDocumentParser constructor comment.
 */
public HTMLDocumentParser() {
	super();
}
/**
 * HTMLDocumentParser constructor comment.
 */
public HTMLDocumentParser(URL aURL) {

	fetchHTMLDocument(aURL.toString());

}
public URL getBase() {

	return _HTMLDoc.getBase();
}
	public HTMLDocument getHTMLDoc(){
	return _HTMLDoc;
	}
public Hashtable getLinksFromHTMLDoc() {

	Hashtable links = new Hashtable();

	if(getHTMLDoc() == null) return links;
	
	ElementIterator iterator = new ElementIterator(getHTMLDoc());
	Element elem;
	URL tmpURL = null;
	while ((elem = iterator.next()) != null) {
		SimpleAttributeSet sas = 
			(SimpleAttributeSet) elem.getAttributes().getAttribute(HTML.Tag.A); 

		if (sas != null) {
			try {

				// Google search--ignore all links that are CSS class defined
				if (sas.getAttribute(HTML.Attribute.CLASS) == null) {
					if (sas.getAttribute(HTML.Attribute.HREF) != null) {
						String value = sas.getAttribute(HTML.Attribute.HREF).toString();
						try {
							tmpURL = new URL(value);
						} catch (MalformedURLException e) {
							if (e.getMessage().startsWith("no protocol")) {
								if (!value.startsWith("#")) {
									if (value.toLowerCase().startsWith("/"))
										if(getBase() != null)
											value = removeFileFromURL(getBase()) + value.substring(1);
									else
										if(getBase() != null)
											value = removeFileFromURL(getBase()) + value;
								}
							}
						}
						if (value.toLowerCase().startsWith("http://")
							|| value.toLowerCase().startsWith("file:")) {
							URL aURL = new URL(value);
							if (!links.containsKey(aURL)) {
								links.put(aURL, aURL);
							}
						}
					}
				}
			} catch (MalformedURLException e) {
				System.err.println(e);
			}
		}
	}
	return links;
}
public String getText() {
	String text = new String();
	try {
		if(_HTMLDoc != null)
		 text = _HTMLDoc.getText(0, _HTMLDoc.getLength());

	} catch (BadLocationException e) {
		System.err.println(e);
		return text;
	}
	return text;
}
public String getTextFromElement(Element elem) {
	int startOffset = elem.getStartOffset();
	int length = elem.getEndOffset() - startOffset;
	String text = new String();
	try {
		text = getHTMLDoc().getText(startOffset, length);
	} catch (Exception e) {
		System.out.println(e);
	}

	return text;
}
/**
 * Insert the method's description here.
 * Creation date: (7/24/2001 7:27:10 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	try {
		HTMLDocumentParser dp = new HTMLDocumentParser();
		dp.removeFileFromURL(new URL("http://cs.usfca.edu/"));
		Hashtable ht = dp.getBackLinksWithGoogle("http://cs.usfca.edu");
		System.out.println(ht.toString());
	} catch (Exception e) {
		System.out.println(e);
	}

}
// Returns URL from Element. If element does not contain a link it returns null
public URL parseLinkFromElement(Element elem) {
	URL aURL = null;
	SimpleAttributeSet sas = 
		(SimpleAttributeSet) elem.getAttributes().getAttribute(HTML.Tag.A); 

	if (sas != null) {
		try {
			if (sas.getAttribute(HTML.Attribute.HREF) != null) {
				String value = sas.getAttribute(HTML.Attribute.HREF).toString();
				aURL = new URL(value);
				if (aURL.getHost() == null)
					if (value.toLowerCase().startsWith("/"))
						value = getBase().toString() + value.substring(1);
					else
						value = getBase().toString() + value;
				if (value.toLowerCase().startsWith("http://")
					|| value.toLowerCase().startsWith("file:///")) {
					aURL = new URL(value);
				}
			}
		} catch (MalformedURLException e) {
			System.err.println(e);
		}
	}
	return aURL;
}
	public void setHTMLDoc(HTMLDocument HTMLDoc){
	_HTMLDoc = HTMLDoc;
	}

/**
 * Insert the method's description here.
 * Creation date: (11/12/2001 2:50:11 PM)
 * @return javax.swing.text.html.HTMLDocument
 * @param url java.lang.String
 */
public void fetchHTMLDocument(String url) {
	try {
		URL aURL = new URL(url);
		URLConnection conn = aURL.openConnection();
		conn.setRequestProperty(
			"User-Agent", 
			"Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0;)"); 
		HTMLDocument HTMLDoc = new HTMLDocument();
		HTMLEditorKit editorKit = new HTMLEditorKit();
		HTMLDoc = (HTMLDocument) editorKit.createDefaultDocument();
		HTMLDoc.putProperty("IgnoreCharsetDirective", Boolean.TRUE);
		//System.out.println("parser.HTMLDocumentParser.HTMLDocumentParser():");
		//System.out.println("opening connection to " + aURL.toExternalForm());

		Reader HTMLReader = new InputStreamReader(conn.getInputStream());
		//System.out.println("connection closed to " + aURL.toExternalForm());
		editorKit.read(HTMLReader, HTMLDoc, 0);
		HTMLDoc.setBase(aURL);
		_HTMLDoc = HTMLDoc;
	} catch (NoRouteToHostException e1) {
		//System.err.println("Internet connection lost");
	} catch (MalformedURLException e2) {
		//System.err.println("Bad URL passed");
	} catch (BadLocationException e3) {
		//System.err.println("Bad Location Exception");
	} catch (IOException e4) {
		//System.err.println("IOException: connection closed");
	} catch (EmptyStackException e5){
		//System.out.println("Empty Stack Exception. Continue...");
		return;
	} 
	//} catch (Exception e) {
		//System.err.println("====>HTMLDocumentParser.fetchHTMLDocument<====");
		//System.err.println(e);
	//}
}

public Hashtable getBackLinksWithGoogle(String url) {
//	fetchHTMLDocument(agent.GoogleWrapper.GOOGLEQUERYSTRING + agent.GoogleWrapper.ADVANCEDSEARCH_BACKLINKPARAM_STRING + url);
	Hashtable links = new Hashtable();

	GoogleWrapper gw = new GoogleWrapper();
	SearchResultVector srv = gw.performBackLinkQuery(url);

	for(int i = 0; i < srv.size(); i++) {
		SearchResult sr = (SearchResult) srv.elementAt(i);
		if(sr.getURL() != null) {
			if(!links.containsKey(sr.getURL())) {
				links.put(sr.getURL(), sr.getURL());
			}
		}
	}
	
	//ElementIterator iterator = new ElementIterator(getHTMLDoc());
	//Element elem;
	//while ((elem = iterator.next()) != null) {
		//SimpleAttributeSet sas =
			//(SimpleAttributeSet) elem.getAttributes().getAttribute(HTML.Tag.A);

		//if (sas != null) {
			//try {
				
				//// Google search--ignore all links that are CSS class defined
				//if (sas.getAttribute(HTML.Attribute.CLASS) == null) {
					//if (sas.getAttribute(HTML.Attribute.HREF) != null) {
						//String value = sas.getAttribute(HTML.Attribute.HREF).toString();
						////if (value.toLowerCase().startsWith("/"))
							////value = getBase().toString() + value.substring(1);
						//if (value.toLowerCase().startsWith("http://")
							//|| value.toLowerCase().startsWith("file:")) {
							//URL aURL = new URL(value);
							//if (!links.containsKey(aURL)) {
								//links.put(aURL, aURL);
							//}
						//}
					//}
				//}
			//} catch (MalformedURLException e) {
				//System.err.println(e);
			//}
		//}
	//}
	return links;
}
/**
 * Insert the method's description here.
 * Creation date: (12/17/2001 4:25:15 PM)
 * @return java.lang.String
 * @param url java.net.URL
 */
public String removeFileFromURL(URL url) {
	String directory = url.getFile();
	int index = directory.lastIndexOf("/");
	if(index > 0)
	 directory = directory.substring(0, index+1);
	
	return url.getProtocol() + "://" + url.getHost() + directory;
}
}